#include "stdafx.h"
#include "Record.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CEPROPVAL *CRecord::NewPropVal(void)
{
	CEPROPVAL *prgPropVal = new CEPROPVAL[5];
	ZeroMemory(prgPropVal, sizeof(CEPROPVAL[5]));
	
	prgPropVal[0].propid = MAKELONG(CEVT_LPWSTR, 1);
	prgPropVal[0].val.lpwstr = m_strTitle.LockBuffer();
	
	prgPropVal[1].propid = MAKELONG(CEVT_LPWSTR, 2);
	prgPropVal[1].val.lpwstr = m_strDesc.LockBuffer();

	prgPropVal[2].propid = MAKELONG(CEVT_I2, 3);
	prgPropVal[2].val.iVal = m_nHour;

	prgPropVal[3].propid = MAKELONG(CEVT_I2, 4);
	prgPropVal[3].val.iVal = m_nMinute;

	prgPropVal[4].propid = MAKELONG(CEVT_I4, 5);
	prgPropVal[4].val.lVal = *((int *)&m_fRating);

	return prgPropVal;
}

void CRecord::DeletePropVal(CEPROPVAL *prgPropVal)
{
	m_strTitle.UnlockBuffer();
	m_strDesc.UnlockBuffer();
	delete prgPropVal;
}

void CRecord::PropValToRecord(CEPROPVAL *prgPropVal)
{
	wcscpy(m_strTitle.GetBuffer(256), prgPropVal[0].val.lpwstr);
	wcscpy(m_strDesc.GetBuffer(1024), prgPropVal[1].val.lpwstr);
	m_nHour = prgPropVal[2].val.iVal;
	m_nMinute = prgPropVal[3].val.iVal;
	m_fRating = *((float *)&prgPropVal[4].val.lVal);
}

